// os9.c

// BVDP 98/05/28
// Read os9 disks from a image on the HD


typedef struct
{
	unsigned char	lsn[3],
		num[2];
}SEG;

typedef struct 
{
	unsigned char	fd_att,
		fd_own[2],
		fd_dat[5],
		fd_lnk,
		fd_siz[4],
		fd_creat[3];
	SEG	fd_seg[48];
}INODE;

typedef struct 
{
	unsigned char	name[28],
		res[1],
		lsn[3];
}DENTRY;

struct sector0
{
	unsigned char	dd_tot[3],
		dd_tks,
		dd_map[2],
		dd_bit[2],
		dd_dir[3],
		dd_own[2],
		dd_att,
		dd_dsk[2],
		dd_fmt,
		dd_spt[2],
		dd_res[2],
		dd_bt[3],
		dd_bsz[2],
		dd_date[5],
		dd_name[32],
		dd_opt[32],
		dd_res1[1],
		dd_sync[4],
		dd_maplsn[4],
		dd_lsnsize[2],
		dd_versid[2];
};



#define FMT_DS 0x1
#define FMT_DD 0x2
#define FMT_DT 0x4
#define FMT_QT 0x8
#define FMT_OT 0x10



struct rbf_opt
{
	unsigned char pd_dtp ,
		pd_drv ,
		pd_stp ,
		pd_typ ,
		pd_dns ,
		pd_cyl[2] ,
		pd_sid ,
		pd_vfy ,
		pd_sct[2] ,
		pd_t0s[2] ,
		pd_sas[2] ,
		pd_ilv ,
		pd_tfm ,
		pd_toffs ,
		pd_soffs ,
		pd_ssize[2] ,
		pd_cntl[2] ,
		pd_trys ,
		pd_res2[8] ;
};

#define TYP_HARD 	0x80		/* hard disk, otherwise floppy */
#define TYP_DDTRK0	0x20		/* Track 0, Side 0 single density */
#define TYP_OLD8	0x01		/* 8" floppy, otherwise 5 1/4" */
#define TYP_OLD 	(0<<1)		/* old type -> TYP_OLD8 */
#define TYP_SIZ8 	(1<<1)		/* physical size 8" */
#define TYP_SIZ5 	(2<<1)		/* physical size 5 1/4" */
#define TYP_SIZ3 	(3<<1)		/* physical size 3 1/2" */
#define TYP_SIZ_MASK 	(7<<1)		/* mask */

#define DNS_DD 		0x01		/* double density (MFM), otherwise singel dens. (FM) */
#define DNS_DT 		0x02		/* double track density 96/135 TPI */
#define DNS_QT 		0x04		/* quad track density 192 TPI */
#define DNS_OT 		0x08		/* oct track density 384 TPI */


